//+------------------------------------------------------------------+
//|                                          Vertical Time Lines.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com 
//|
//| Author: File45
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_plots 0

enum LW
{
   One = 1,
   Two = 2,
   Three = 3,
   Four = 4,
   Five = 5,
};   

// DEFAULT INPUTS : START
//-----------------------------------------------------
input int Historical_Days = 50; // Historical days
  
input color  Line_1_Color = clrDodgerBlue;      // Line 1  Color 
input bool   Line_1_Visible = true;             // Line 1  Visible
input string Line_1_Time = "08:00";             // Line 1  Time
input LW     Line_1_Width = One;                // Line 1  Width
input ENUM_LINE_STYLE Line_1_Style = STYLE_DOT; // Line 1  Style

input color  Line_2_Color = clrDodgerBlue;      // Line 2  Color
input bool   Line_2_Visible = true;             // Line 2  Visible
input string Line_2_Time = "09:00";             // Line 2  Time 
input LW     Line_2_Width = One;                // Line 2  Width
input ENUM_LINE_STYLE Line_2_Style = STYLE_DOT; // Line 2  Style

input color  Line_3_Color = clrMagenta;         // Line 3  Color
input bool   Line_3_Visible = false;            // Line 3  Visible
input string Line_3_Time = "10:00";             // Line 3  Time
input LW     Line_3_Width = One;                // Line 3  Width
input ENUM_LINE_STYLE Line_3_Style = STYLE_DOT; // Line 3  Style

input color  Line_4_Color = clrMagenta;         // Line 4  Color
input bool   Line_4_Visible = false;            // Line 4  Visible
input string Line_4_Time = "11:00";             // Line 4  Time
input LW     Line_4_Width = One;                // Line 4  Width
input ENUM_LINE_STYLE Line_4_Style = STYLE_DOT; // Line 4  Style

input color  Line_5_Color = clrDarkOrange;      // Line 5  Color
input bool   Line_5_Visible = false;            // Line 5  Visible
input string Line_5_Time = "12:00";             // Line 5  Time
input LW     Line_5_Width = One;                // Line 5  Width
input ENUM_LINE_STYLE Line_5_Style = STYLE_DOT; // Line 5  Style

input color  Line_6_Color = clrDarkOrange;      // Line 6  Color
input bool   Line_6_Visible = false;            // Line 6  Visible 
input string Line_6_Time = "13:00";             // Line 6  Time
input LW     Line_6_Width = One;                // Line 6  Width
input ENUM_LINE_STYLE Line_6_Style = STYLE_DOT; // Line 6  Style  
//----------------------------------------------------- 
// DEFAULT INPUTS : END 

string T1_End = "Time_Line_1"; 
string T2_End = "Time_Line_2"; 
string T3_End = "Time_Line_3";  
string T4_End = "Time_Line_4"; 
string T5_End = "Time_Line_5";  
string T6_End = "Time_Line_6";    
 

int OnInit()
{
   DeleteObjects();
  for (int i=0; i<Historical_Days; i++) 
  {
     CreateObjects("T1"+ IntegerToString(i), Line_1_Color);
     ObjectSetInteger(0, "T1"+IntegerToString(i), OBJPROP_WIDTH, Line_1_Width);
     ObjectSetInteger(0, "T1"+IntegerToString(i), OBJPROP_STYLE, Line_1_Style);
     
     CreateObjects("T2"+IntegerToString(i), Line_2_Color);
     ObjectSetInteger(0, "T2"+IntegerToString(i), OBJPROP_WIDTH, Line_2_Width);
     ObjectSetInteger(0, "T2"+IntegerToString(i), OBJPROP_STYLE, Line_2_Style);
     
     CreateObjects("T3"+IntegerToString(i), Line_3_Color);
     ObjectSetInteger(0, "T3"+IntegerToString(i), OBJPROP_WIDTH, Line_3_Width);
     ObjectSetInteger(0, "T3"+IntegerToString(i), OBJPROP_STYLE, Line_3_Style);
     
     CreateObjects("T4"+IntegerToString(i), Line_4_Color);
     ObjectSetInteger(0, "T4"+IntegerToString(i), OBJPROP_WIDTH, Line_4_Width);
     ObjectSetInteger(0, "T4"+IntegerToString(i), OBJPROP_STYLE, Line_4_Style);
     
     CreateObjects("T5"+IntegerToString(i), Line_5_Color);
     ObjectSetInteger(0, "T5"+IntegerToString(i), OBJPROP_WIDTH, Line_5_Width);
     ObjectSetInteger(0, "T5"+IntegerToString(i), OBJPROP_STYLE, Line_5_Style);
     
     CreateObjects("T6"+IntegerToString(i), Line_6_Color);
     ObjectSetInteger(0, "T6"+IntegerToString(i), OBJPROP_WIDTH, Line_6_Width);
     ObjectSetInteger(0, "T6"+IntegerToString(i), OBJPROP_STYLE, Line_6_Style);
  }

   return(INIT_SUCCEEDED);
}

void deinit() 
{
  DeleteObjects();
}

void CreateObjects(string no, color cl)
{
  ObjectCreate(0, no, OBJ_VLINE, 0, 0,0, 0,0);
  //ObjectSet(no, OBJPROP_WIDTH, Line_Width_1_2_3_4_or_5);
  //ObjectSet(no, OBJPROP_STYLE, Line_Style);
  ObjectSetInteger(0, no, OBJPROP_COLOR, cl);
  ObjectSetInteger(0, no, OBJPROP_BACK, false);
}

void DeleteObjects() 
{
  for (int i=0; i<Historical_Days; i++) 
  {
    ObjectDelete(0,"T1"+IntegerToString(i));
    ObjectDelete(0,"T2"+IntegerToString(i));
    ObjectDelete(0,"T3"+IntegerToString(i));
    ObjectDelete(0,"T4"+IntegerToString(i));
    ObjectDelete(0,"T5"+IntegerToString(i));
    ObjectDelete(0,"T6"+IntegerToString(i));
  }
}

void DrawObjects(datetime dt, string no, string tb, string te) 
{
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;

  t1=StringToTime(TimeToString(dt, TIME_DATE)+" "+tb);
  t2=StringToTime(TimeToString(dt, TIME_DATE)+" "+te);
  b1=iBarShift(_Symbol, PERIOD_CURRENT, t1);
  b2=iBarShift(_Symbol, PERIOD_CURRENT, t2);
  p1=iHigh( _Symbol, PERIOD_CURRENT, iHighest(_Symbol, PERIOD_CURRENT, MODE_HIGH, b1-b2, b2) );
  p2=iLow(_Symbol, PERIOD_CURRENT, iLowest (_Symbol, PERIOD_CURRENT, MODE_LOW , b1-b2, b2) );
  ObjectSetInteger(0, no, OBJPROP_TIME, 0 , t1);
  ObjectSetInteger(0, no, OBJPROP_TIME, 1 , t2);
  ObjectSetDouble(0, no, OBJPROP_PRICE, 0, p1);
  ObjectSetDouble(0, no, OBJPROP_PRICE, 1, p2);
}

datetime decDateTradeDay (datetime dt) 
{
  MqlDateTime tm;
  TimeToStruct(dt,tm);
  
  /*
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);
  */

  tm.day--;
  if (tm.day==0) 
  {
    tm.mon--;
    if (tm.mon==0) 
    {
      tm.year--;
      tm.mon=12;
    }
    if (tm.mon==1 || tm.mon==3 || tm.mon==5 || tm.mon==7 || tm.mon==8 || tm.mon==10 || tm.mon==12) tm.day=31;
    if (tm.mon==2) if (MathMod(tm.year, 4)==0) tm.day=29; else tm.day=28;
    if (tm.mon==4 || tm.mon==6 || tm.mon==9 || tm.mon==11) tm.day=30;
  }
  //return(StringToTime(IntegerToString(ty)+"."+IntegerToString(tm)+"."+IntegerToString(td)+" "+IntegerToString(th)+":"+IntegerToString(ti)));
  return( StructToTime(tm) );
}




int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
 {
   MqlDateTime tm;
   datetime dt=TimeCurrent(); //CurTime();

   for (int i=0; i<Historical_Days; i++) 
   {
      if(Line_1_Visible == true)
      {
         DrawObjects(dt, "T1"+IntegerToString(i), Line_1_Time, T1_End);
      }
      if(Line_2_Visible == true)
      {
         DrawObjects(dt, "T2"+IntegerToString(i), Line_2_Time, T2_End);
      }
      if(Line_3_Visible == true)
      {
         DrawObjects(dt, "T3"+IntegerToString(i), Line_3_Time, T3_End);
      }
      if(Line_4_Visible == true)
      {
         DrawObjects(dt, "T4"+IntegerToString(i), Line_4_Time, T4_End);
      }
      if(Line_5_Visible == true)
      {
         DrawObjects(dt, "T5"+IntegerToString(i), Line_5_Time, T5_End);
      }
      if(Line_6_Visible == true)
      {
         DrawObjects(dt, "T6"+IntegerToString(i), Line_6_Time, T6_End);
      }
        
      do
      {
        dt=decDateTradeDay(dt);
        TimeToStruct(dt,tm);
      }
      while( tm.day_of_week>5 );

   }

   return(rates_total);
}

